local mapname = 'mountain_fortress_v3'
local Collapse = require 'modules.collapse'
local mapindex  = 9999
local on_tick = function()
	--一分钟更新
	local collapse_pos = Collapse.get_position()
	local collapse_y = collapse_pos.y
	local tick = game.tick
	-- if tick % 180 == 0 then
		-- for _, player in pairs(game.connected_players) do
			-- local pl_inv = player.get_inventory(defines.inventory.character_main)
			-- if pl_inv then
				-- local pl_empty = pl_inv.count_empty_stacks()
				-- if pl_empty < 2 then
					-- --player.teleport(player.surface.find_non_colliding_position('character', game.forces.player.get_spawn_position(player.surface), 3, 0, 5),player.surface)
					-- player.print("你的背包剩不到5格.请及时清理你的背包.",{r = 255, g = 0, b = 125})
					-- goto continue
				-- end
				-- if pl_empty < 7 then player.print("你的背包剩不到10格.请及时清理你的背包.",{r = 255, g = 0, b = 125}) goto continue end
				-- --if pl_empty < 15 then player.print("你的背包剩不到15格.请及时清理你的背包.",{r = 255, g = 0, b = 125}) goto continue end
				-- --if pl_empty < 20 then player.print("你的背包剩不到20格.请及时清理你的背包.",{r = 255, g = 0, b = 125}) goto continue end
				-- ::continue::
			-- end
		-- end
	-- end


	
	if  tick % 3600 == 0 then
		for _, surface in pairs(game.surfaces) do
			--game.print(surface.name .. '开始')
			local surfacename = surface.name
			local namelen = string.len(surfacename)
			if namelen > 18 then 
				--game.print('找到大于18长度')
				if string.sub(surfacename,1,17) == 'mountain_fortress' then
					--game.print('找到 mountain_fortress')
					--game.print('保存地图数据:' .. surface.index  .. '名称：' .. surface.name)
					mapindex  = surface.index
					--game.print('保存地图数据:' .. surface.index  .. '名称：' .. surface.name .. tick/3600 .. ' 分')
				end
			end 
			--清理玩家物流回收区
			-- for _, player in pairs(game.connected_players) do
				-- local pl_inv = player.get_inventory(defines.inventory.character_trash)
				-- pl_inv.clear()
			-- end
		end
		--game.print(mapindex)
		if tick % 18000 == 0 and mapindex ~= 9999 and game.surfaces[mapindex] ~= nil then
			for chunk in game.surfaces[mapindex].get_chunks() do
				if (collapse_y - (chunk.y * 32))  <= 9200 then 
					if chunk.x < 8 and chunk.x > -9 then
						for _, e in pairs(game.surfaces[mapindex].find_entities_filtered{area=chunk.area, type='corpse'}) do
							e.destroy()
						end
						--game.print('自动清理全图尸体(5分钟执行一次)')
						for _, e in pairs(game.surfaces[mapindex].find_entities_filtered{area = chunk.area, type = 'item-entity', name = 'item-on-ground'}) do
							e.destroy()
						end
						--game.print('自动清理全图落地物品(5分钟执行一次)')
					end
					
					if chunk.x > 8 or chunk.x < -9 then 
						game.surfaces[mapindex].delete_chunk({chunk.x,chunk.y})
						--game.print('删除：' .. chunk.x .. ',' .. chunk.y)
						--game.print('自动清理无用地图块(5分钟执行一次)')
					end
				end
			end
			game.print('自动清理【无用地图块,落地物品，尸体】5分钟执行一次.')
		end
	end
	
	
	
end
-- local on_tick = function()
	-- local tick = game.tick
    -- if tick % 60 == 0 then
        -- if tick % 1200 == 0 then
		-- game.print('自动清理塌陷地图(60分钟一次)' .. tick)
        -- end
    -- end
-- end
function on_pre_player_died(event)
		local player = game.players[event.player_index]
		local player_main = player.get_inventory(defines.inventory.character_main)--获取主空间
		local coin_number = player_main.get_item_count('rocket-part')
		if coin_number < 1 then  
			player.print('背包无[火箭组件].无法保命回城一次.',{r = 0.75, g = 0.0, b = 0.0})
			goto continue 
		end
		player_main.remove({name = 'rocket-part',count = 1})--主空间删除坦克
		game.print('玩家' .. player.name .. ' 扣除火箭组件1个，满血回城...',{r = 0.75, g = 0.0, b = 0.0})
		local surface = player.surface
        player.teleport(surface.find_non_colliding_position('character', game.forces.player.get_spawn_position(surface), 3, 0, 5), surface)
        player.character.health = player.character.prototype.max_health + player.character_health_bonus + player.force.character_health_bonus
		::continue::  
end
local function on_built_entity(event)
	if event.created_entity.name == "burner-inserter" then
		local entity_inventory = event.created_entity.get_inventory(defines.inventory.fuel)
		if entity_inventory.can_insert({name = "nuclear-fuel", count = 1}) then
			entity_inventory.insert({name = "nuclear-fuel", count = 1})
			event.created_entity.force = 'neutral'
		end
	end
	if event.created_entity.name == "stone-wall"then
		event.created_entity.force = 'neutral'
	end
end

local Event = require 'utils.event'
Event.on_nth_tick(15, on_tick)

--on_pre_player_died

Event.add(defines.events.on_built_entity, on_built_entity)
Event.add(defines.events.on_pre_player_died, on_pre_player_died)